<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

/*******************************************************************************

    Author ......... Eduard Kamburjan 
    Contact ........ cacti_brezel@gmx.de
    Home Site ...... http://forums.cacti.net/viewtopic.php?t=31124
    Program ........ Notices 
    Version ........ 0.2c
    Purpose ........ Notices per Graph
    Requirements ... Settings Plugin

*******************************************************************************/



function plugin_init_Notices() {
    // This is where you hook into the plugin archetecture 
    global $plugin_hooks;
    $plugin_hooks['config_settings']['Notices'] = 'Notices_config_settings';
    $plugin_hooks['config_arrays']['Notices'] = 'Notices_config_arrays';
    $plugin_hooks['graph_buttons']['Notices'] = 'Notices_graph_buttons';
}


function Notices_config_arrays () {
        global $user_auth_realms, $user_auth_realm_filenames, $menu;
        if (function_exists('api_plugin_register_realm')) {
        api_plugin_register_realm('Notices', 'add_notice.php', 'Notices', 124);
        api_plugin_register_realm('Notices Add Comments', 'add_comment.php', 'Notices Add Comments', 125);
        } else {
        $user_auth_realms[124]  = 'Notices';
        $user_auth_realms[125]  = 'Notices Add Comments';
        $user_auth_realm_filenames['add_notice.php']              = 124;
        $user_auth_realm_filenames['add_comment']    		  = 125;
        }
}


function Notices_version () {
    return array( 'name'    => 'Notices',
            'version'   => '0.2d',
            'longname'  => 'Notices',
            'author'    => 'Eduard Kamburjan',
            'homepage'  => 'http://forums.cacti.net/viewtopic.php?t=31124',
            'email' => 'cacti_brezel@gmx.de',
            'url'      => 'http://forums.cacti.net/viewtopic.php?t=31124'
            );
}

function Notices_config_settings () {
//this puts the following form elements on the Settings->Misc tab in cacti
    global $tabs, $settings;
    $tabs["misc"] = "Misc";

    $temp = array(
        "Notices_header" => array(
            "friendly_name" => "Notices",
            "method" => "spacer",
            ),
        "Notices_check" => array(
            "friendly_name" => "Per Host Notices",
            "description" => "Check this to display the notices per Host and not per Graph",
            "method" => "checkbox",
            "default" => "off",
            ),
        "Notices_check_always" => array(
            "friendly_name" => "Always Open",
            "description" => "Check this to open the table automaticly",
            "method" => "checkbox",
            "default" => "off",
            ),
        "Notices_check_ajax" => array(
            "friendly_name" => "Use Ajax",
            "description" => "Check this to activate Ajax (Some browser have Problems using Ajax)",
            "method" => "checkbox",
            "default" => "off",
            ),
        "Notices_check_comments" => array(
            "friendly_name" => "Print in Graph",
            "description" => "Check this to allow to print the notices in the Graph (only with Ajax)",
            "method" => "checkbox",
            "default" => "off",
            ),
        "notices_size" => array(
            "friendly_name" => "Notices Size",
            "description" => "Size of the notices table",
            "method" => "drop_array",
            "array" => array(
                        "small" => "Small",
                        "normal" => "Normal",
                        "big" => "Big"
                        ),
            "default" => "small",
            ),
    );
    if (isset($settings["misc"]))
        $settings["misc"] = array_merge($settings["misc"], $temp);
    else
        $settings["misc"]=$temp;
}


function Notices_graph_buttons($args) {
        global $config,$rra;

        $local_graph_id = $args[1]['local_graph_id'];
        $id=$local_graph_id;
	#/*
	$rra = $args[1]['rra'];

if(!isset($_GET['action']))
{
        include("load.php");
        include("baum.php");
} else if (!($_GET['action'] == 'zoom')){
	include("load.php");
	include("baum.php");
    }
}

function Notices_show_tab () {
    //This checks to see if user has access to the tab and if so displays it
    global $config, $user_auth_realms, $user_auth_realm_filenames;
    $realm_id2 = 0;

    if (isset($user_auth_realm_filenames{basename('notices.php')})) {
        $realm_id2 = $user_auth_realm_filenames{basename('notices.php')};
    }
    if ((db_fetch_assoc("select user_auth_realm.realm_id
        from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
        and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {
        
    }
    Notices_setup_table();
}

function Notices_setup_table () {
    $realm_id=124;
    global $config, $database_default;
    include_once($config["library_path"] . "/database.php");
    $sql = "show columns from host from " . $database_default;
    $result = mysql_query($sql) or die (mysql_error());
    $found = false;
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        if ($row['Field'] == 'Notices')
            $found = true;
    }
    if (!$found) {
        $sql = "alter table host add Notices char(3) default 'on' not null after disabled";
        $result = mysql_query($sql) or die (mysql_error());
        $sql = "INSERT INTO `user_auth_realm` VALUES ($realm_id, 1);";
        $result = mysql_query($sql); // or die (mysql_error());
    }
}

?>
